/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		vadc_usage.cpͯ ̧
 *
 *		vadc_usage.cp̒`ƌ^錾܂݂܂B
 *
 * \par pLq:
 *		AVR456: SB201̧ѳgp҂̎
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: 4012 $
 * $Date		: 2008N62 13:45:17 +0200 (ma, 02 jun 2008) $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#ifndef VADC_H
#define VADC_H

/* ݸٰ */

#include "common.h"
#include "battery_pack_parameters.h"

/* ` */

//! ʎړxpޯĐ(16384)BɂĂްĂVADCB
#define VADC_SCALE_BITS				14

//! xł̐x𑝂߂VADCd肩̌ʂ̎ړxBޯĂŁA
//! (VADC̖{̂ߊ10{g傳Ă܂B)
#define VADC_TEMP_VOLTAGE_SCALING	1

//! ADCٓ͐B̕ϐ̑傫`Âɑsɾِ̍\ݒ肪g
//  ꍇ2łȂ΂Ȃ܂B
#define CELL_INPUTS					BATTPARAM_CELLS_IN_SERIES
//! VADC͐B̕ϐ̑傫`Âɑsɾِ̍\ݒ肪g
//  ꍇ2łȂ΂Ȃ܂B
#define VADC_INPUTS					CELLTEMPERATURE_INPUTS


typedef enum vadcStateEnum { VADC_NOT_RUNNING = 0, VADC_RUNNING, VADC_SCAN_FAILED } vadcState_t;
struct VADC_Status {
	vadcState_t	state : 2;
	uint8_t     cell1VoltageReady : 1;
	uint8_t     cell2VoltageReady : 1;
	uint8_t     vtempReady : 1;
	uint8_t     cellTempReady : 1;
};

// !!!!! 񋓂ƒ`̗XV邱ƂɒӂĂB
//! ِ֐ւ̓͂ł鏈Ŏg^`
typedef enum vadcIndex { CELL1 = 1, CELL2 = 2, VTEMP= 4, VADC0 = 5, VADC1 = 6} vadcIndex_t;
// O^߂Ŏg`
#define DEF_CELL1		1
#define DEF_CELL2		2
#define DEF_VTEMP		4
#define DEF_VADC0		5
#define DEF_VADC1		6

// HVAp[d
#define VB_DUVR_DFET	500		//!< DFET޲ނnd


/***** ^錾 */

void VADC_ScanConfig(vadcIndex_t Cells, vadcIndex_t Vadcs, vadcIndex_t vtempScan);
uint8_t VADC_GetScanConfig();
err_t VADC_StartScan(void);
vadcState_t VADC_ScanState(void);
void VADC_ClearReadyFlags();
bool VADC_CellTempReady(void);
bool VADC_VTempReady(void);
bool VADC_Cell1VoltageReady(void);
bool VADC_Cell2VoltageReady(void);

void VADC_InitializeVadcCoefficients(void);
uint16_t VADC_readCellVoltage(vadcIndex_t cellIndex);
uint16_t VADC_readVadc(vadcIndex_t vadcIndex);
uint16_t VADC_readSystemTemperature(void);

err_t DUVR_DisableCheck();

#endif // VADC_H
