/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		CC-ADCʏ̧ѳPʕ
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

/******************************************************************************
 ݸٰ ̧
******************************************************************************/
#include "common.h"
#include "battery_pack_parameters.h"
#include "battery_current_monitoring.h"
#include "ccadc.h"

/******************************************************************************
 S(َ̧)ϐ
******************************************************************************/
int32_t lastCurrent;
int32_t lastOffsetCalibratedCurrent;
bool discharge;
int32_t averageCurrent;			//<! 2^AVERAGE_CURRENT_SCALINGɂĎړx

uint16_t ticks2mAMagicNumber;	// mA𓾂邽߂̎Ŏgp: (ccadc_ticks~magicNumber)/2^16=mA

/******************************************************************************
 ֐錾
******************************************************************************/

/******************************************************************************/
/*! \brief ēxCC-ADCl̓di[(mVAt18ޯ)
 *
 * \param	current	(nmVƂĕ\ꂽ)dr߯̓o͓d̗
 */
void BATTCUR_StoreCurrent( int32_t current )
{
	lastCurrent = current;
	lastOffsetCalibratedCurrent = current + CCADC_GetAccOffset();
	if( 0 >= lastOffsetCalibratedCurrent) {
		discharge = true;
	} else {
		discharge = false;
	}
}

/******************************************************************************/
/*! \brief ŌCC-ADCld(t18ޯ)
 *
 * \return	(nmVƂĕ\ꂽ)dr߯̓o͓d̗
 */
int32_t BATTCUR_GetCurrent( void )
{
	return lastCurrent;
}

/******************************************************************************/
/*! \brief ŌCC-ADClψʍZꂽd
 *
 * \return	(nmVƂĕ\ꂽ)dr߯̓o͓d̗
 */
int32_t BATTCUR_GetOffsetCalibratedCurrent( void )
{
	return lastOffsetCalibratedCurrent;
}

/******************************************************************************/
/*! \brief Ō1Ԃ̕ϓdvZĊi[(t18ޯ)
 *
 * ̎p̎Ԋ͊T1bƉBς"whg"gČvZAϓd
 * 𐄒肵܂B؏炷߂Ɏۂ̕ςɑ@łB
 *
 * \param	current	(nmVƂĕ\ꂽ)dr߯̓o͓d̗
 */
void BATTCUR_UpdateAverageCurrent( int32_t current )
{
	// whg"=31/32~Âl+1/32~l炵l"Ɏg܂B
	// ǂA؂̂Č덷苎邽߂ɓdړxg傳܂B
	averageCurrent *= 31;
	averageCurrent += current * (1<<AVERAGE_CURRENT_SCALING);

	// Eړ͐̐̏Zŏ肭Ȁꍇ̋t͏Zsyɍ
	// łB
	if(averageCurrent > 0) {
		// Zpۂ߂𓾂邽߂ɏ̔Z
		averageCurrent += 16;
		averageCurrent >>= 5;		// /32
	} else if (averageCurrent < 0) {
		averageCurrent = -averageCurrent;
		// Zpۂ߂𓾂邽߂ɏ̔Z
		averageCurrent += 16;
		averageCurrent >>= 5;		// /32
		averageCurrent = -averageCurrent;
	}
}
/******************************************************************************/
/*! \brief Ō1Ԃʂϓd̐(t18ޯ)
 *
 * \return	(nmVƂĕ\ꂽ)dr߯̕ϓo͓d̗
 */
int32_t BATTCUR_GetAverageCurrent( void )
{
	if(averageCurrent < 0) {
		// ׂ: ̏Zۂ߂܂A̒l͉dvȂ̂ɎgꂸÂɍ̏΂ĂB
		return -(-averageCurrent >> AVERAGE_CURRENT_SCALING);
	} else {
		return (averageCurrent >> AVERAGE_CURRENT_SCALING);
	}
}

/******************************************************************************/
/*! \brief d޲Nx(d͓ɓ鎞)?
 *
 * \param	current	(CCADC)޲xȉ𒲂ׂd
 *
 * \return	d""̏ꍇɐ^Ԃ܂B
 */
bool BATTCUR_IsCurrentLow( int32_t current )
{
	if(0 > current) {
		current = -current;
	}

	return ( (int32_t)battParams_sram.activeCurrentThresholdInTicks > current );
}

/******************************************************************************/
/*! \brief ϓdv
 *
 * \param	current	ŏ̓d
 */
void BATTCUR_InitializeAverageCurrent( int32_t current )
{
	averageCurrent = current * (1<<AVERAGE_CURRENT_SCALING);
}

/******************************************************************************/
/*! \brief d͓dr[dA܂͕d?
 *
 *  ψ(̾)ZdɎgp
 *
 * \return	d̗ꂪd̏ꍇɐ^Ԃ܂B
 */
bool BATTCUR_IsDischargeOngoing( void )
{
	return discharge;
}

/******************************************************************************/
/*! \brief mAϊ̂߂ccadc_ticksɑ΂閂@̐vZ
 *
 * ̊֐̖ڕW͎̎Ŏg"magic"̐l邱ƂłB
 * ccadc_ticks~magic=mA
 * AmagicɏȐl̂߁A2^16Ŏړxg傳ÂɎ͈ȉłB
 * (ccadc_ticks~magic)/2^16=mA
 *
 * A/tickp̎: ref/(shunt~2^17) (SIPʌnAAVƃ)
 *
 * g萔: 0.11VCCADCpQƊłB
 *			 2^16magic̐lǂʎړxg傳邩łB
 *
 * \param	shuntResistance	ʃł̕R
 */
void BATTCUR_CalculateMagicNumber(uint16_t shuntResistance)
{
	uint32_t dividend = 55000000;	// (ref~1000~1000000~2^16)/2^17
									// ŏIIȓȂmAœ邽߂Ɂ~1_000A
									// shuntResistanceʃȂ̂Ł~1_000_000A
									// Zł̐x𑝂߂ɉ\Ȍ艓֎ړxg傷邽߂Ɂ~2^16A
									// V/tickref/2^17Ȃ̂/2^17
	
	dividend += (shuntResistance >> 1);		// ۂ߂𓾂邽߂ɏ̔Z

	ticks2mAMagicNumber = dividend/shuntResistance;
}

/*******************************************************************/
/*! \brief CCADCmAɕϊ
 *
 * : (ccadc_ticks~magicNumber)/2^16=mA
 *
 * \param	ticks	mAɕϊ邽߂CCADCݐύ
 */
int16_t BATTCUR_Ticks2mA(int32_t ticks)
{
	ticks *= ticks2mAMagicNumber;

	if(ticks >= 0) {
		ticks += (1ul<<15);
		ticks >>= 16;
	} else {
		ticks = -ticks;
		ticks += (1ul<<15);
		ticks >>= 16;
		ticks = -ticks;
	}

	return (int16_t)ticks;
}

/*******************************************************************/
/*! \brief mACCADCɕϊ
 *
 * : ccadc_ticks=(mA~2^16)/magicNumber
 *
 * \note mÁ}16384傫邱Ƃł܂(AޯĂ14ޯĂ𒴂Ďg܂B)
 *
 * \param	mA_in	CCADCݐύɕϊmA
 */
int32_t BATTCUR_mA2Ticks(int16_t mA_in)
{
	int32_t temp = mA_in*(1ul<<16);		// 2^16

	temp /= ticks2mAMagicNumber;

	return (int16_t)temp;
}

/****************************************/
/*! \brief mARCC CCADCɕϊ
 *
 * \param	mA_in	RCCɕϊmA
 */
int32_t BATTCUR_mA2RccTicks(int16_t mA_in) {
	uint32_t temp = BATTCUR_mA2Ticks(mA_in);

	// RCC͗ݐύ2.5{قǂ̑傫łB
	temp >>= 5; 

	return temp;
}
