/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		dɊÂď[d̏Ԃ𐄒肷邽߂̊֐
 *
 * \par pLq:
 *		AVR456: SB201̧ѳgp҂̎
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

/* ݸٰ */
#include "common.h"
#include "vadc.h"
#include "ccadc.h"
#include "voltage_based_SoC.h"
#include "rtc.h"
#include "battery_current_monitoring.h"

/* dp` */
#define VOLTAGE_EMPTY	(VoltageTable[0][VOLTAGE_TABLE_SIZE-1])
#define VOLTAGE_FULL	(VoltageTable[0][0])

uint16_t ConvertVoltageToSoC(uint16_t inputVoltage);
int16_t ConvertDigitalToCurrent(void);
int16_t ConvertDigitalToVoltage(void);

/* d\͓dSoCԂ̊蓖Ă܂݂܂Bl;ق̊JHd\܂B
 * ̒l<0.05C̒ᗦžقd邱ƂɂāA܂͎w藦Ŗ@łď[d
 * Ǎɑ̕ϓdgƂɂđ肳ׂłB
 * SoCl00% SoC1000100% SoC\0`1000͈̔͂łB
 */
// TrustFireٗpz
//#define VOLTAGE_TABLE_SIZE	12
//uint16_t VoltageTable[2][VOLTAGE_TABLE_SIZE] = { {4000,3940,3848,3779,3756,3729,3672,3639,3575,3502,3313,3000}, {1000,900,700,500,400,300,150,100,70,50,20,0} };

// Keithley instrumentł10mAׂłTrustFireٗpz
#define VOLTAGE_TABLE_SIZE 21
__flash uint16_t VoltageTable[2][VOLTAGE_TABLE_SIZE] = { 
	{4180,4112,4074,4013,3973,3922,3858,3810,3782,3762,3751,3725,3701,3684,3678,3663,3607,3511,3350,3200,2771 },
	{1000,950 ,900 ,850 ,800 ,700 ,600 ,500 ,400 ,300 ,250 ,200 ,150 ,120 ,100 ,80  ,60  ,40  ,20  ,10  ,0 } };

// Dellٗpz
//uint16_t VoltageTable[2][VOLTAGE_TABLE_SIZE] = { {4100,3923,3755,3718,3696,3664,3638,3596,3530,3423,3232,2950}, {1000,850,600,500,400,300,250,200,150,100,50,0} };

/* ̕ϐ͊JHœdɊÂŐVSoC܂݂܂B
uint16_t OpenCircuitSoC;

/* ̕ϐ͕bōŌSoCXV̎Ԃ܂݂܂(SoC͓dĂ鎞
 * ɂXV܂)B
 * 65534Œ~Ĉ܂B
 */
uint16_t LastUpdated;

/* Ō̊d牽battParam.openCircuitRelaxationTime? */
uint8_t relaxationTimer;

/* ֐ */

/*! \brief SoCvZ
 *
 * ̊֐͗\ƊJHSoC̗XVAdJHdۏ؂鎞(Ⴆ
 * ΁AԂ̎Ւf̎n)s܂B
 */
void VBSoC_Init(void)
{
	uint16_t lowestCellVoltage;

	// ǂ̾قŒdmAvZłg܂(1ق͗eՂł)B
#if BATTPARAM_CELLS_IN_SERIES == 1
	lowestCellVoltage = VADC_readCellVoltage(CELL1);
#elif BATTPARAM_CELLS_IN_SERIES == 2
	{
		uint16_t voltageCell1 = VADC_readCellVoltage(CELL1);
		uint16_t voltageCell2 = VADC_readCellVoltage(CELL2);
		lowestCellVoltage = (voltageCell1 < voltageCell2) ? voltageCell1 : voltageCell2;
	}
#endif

	OpenCircuitSoC = ConvertVoltageToSoC(lowestCellVoltage);
}

/*! \brief SoCXV
 *
 * bɈxsׂłB
 *
 * battParams.openCircuitRelaxationTimeĂΊJHSoCXV܂B
 *
 * \return	openCircuitSoCXVĂΐ^Ԃ܂B
 */
bool VBSoC_Update(void)
{
	// 0ɖ߂LastUpdated]܂A65534bɗ܂邱Ƃ͖肠܂B
	// LastUpdatedؾĂԂ̎ԂۂɒȂłAŜ߂ɗ
	// ƂłB
	if(LastUpdated < 65535) {
		++LastUpdated;
	}

	// JHSoCXV̎Ԃ
	if(RTC_GetMinutes() == relaxationTimer) {
		// Ō̍XV30b𒴂ĂꍇɂXV
		// ׂ: `邩܂񂪁Aۂ̒l͏dvł͂ȂAPɕb
		//			   ̌vZ邽߂łBēdႢ(Ȃ
		//			   ɂȂȂ)߁A[d󋵂͔ɒxς܂B
		if(LastUpdated >= 30) {
			// ǂ̾قŒdmAvZłg܂(1ق͗eՂł)B
			uint16_t lowestCellVoltage;

#if BATTPARAM_CELLS_IN_SERIES == 1
				lowestCellVoltage = VADC_readCellVoltage(CELL1);
#elif BATTPARAM_CELLS_IN_SERIES == 2
			{
				uint16_t voltageCell1 = VADC_readCellVoltage(CELL1);
				uint16_t voltageCell2 = VADC_readCellVoltage(CELL2);
				lowestCellVoltage = (voltageCell1 < voltageCell2) ? voltageCell1 : voltageCell2;
			}
#endif

			OpenCircuitSoC = ConvertVoltageToSoC(lowestCellVoltage);
			LastUpdated = 0;
			return true;
		}
	}
	return false;
}

/********************************************************************************/
/*! \brief vؾ
 *
 * ޲޲łȂɂ̊֐𑖂点ĂB
 *
 */	
void VBSoC_ResetTimer(void) {
	relaxationTimer = RTC_GetMinutes() + battParams.openCircuitRelaxationTime;
}

/********************************************************************************/
/*! \brief JHdSoCXVbOɍXVꂽԂ܂B
 *
 * \return	ŌOCV SoCXV̕b
 */
uint16_t VBSoC_OCSoCLastUpdated(void) {
	return LastUpdated;
}

/********************************************************************************/
/*! \brief Ō̊JH[dԂԂ܂B
 *
 * VBSoC_OCSoCLastUpdated֐łꂪǂʌÂ
 */
uint16_t VBSoC_OCSoC(void) {
	return OpenCircuitSoC;
}

/********************************************************************************/
/*! \brief Ōɗ\[dԂԂ܂B
 *
 */
uint16_t VBSoC_EstimatedSoC(void) {
	int16_t result_volt;
	uint16_t lowestCellVoltage;

	// ǂ̾قŒdmAvZłg܂(1ق͗eՂł)B
#if BATTPARAM_CELLS_IN_SERIES == 1
	lowestCellVoltage = VADC_readCellVoltage(CELL1);
#elif BATTPARAM_CELLS_IN_SERIES == 2
	{
		uint16_t voltageCell1 = VADC_readCellVoltage(CELL1);
		uint16_t voltageCell2 = VADC_readCellVoltage(CELL2);
		lowestCellVoltage = (voltageCell1 < voltageCell2) ? voltageCell1 : voltageCell2;
	}
#endif

	// dd~vZ(d͕dɕŏ[dɐ)
	result_volt = ConvertDigitalToVoltage();

	// ٓdƓd~ɊÂSoC𐄒
	return ConvertVoltageToSoC(lowestCellVoltage - result_volt );
}

/**********************************************************/
/*! \brief SoCϊ
 *
 * ϊ\gēdSoCɕϊ
 *
 * \return	SoC(0`100)
 */
uint16_t ConvertVoltageToSoC(uint16_t inputVoltage)
{
	uint16_t socval = 0;
	uint8_t i = 1;

	// d臒lȏォ
	if(inputVoltage >= VOLTAGE_FULL)
	{
		// SoC100%ɐݒ
		socval = 100;
	}
	// d臒lȉ
	else if(inputVoltage <= VOLTAGE_EMPTY)
	{
		// SoC0%ɐݒ.
		socval = 0;
	}
	// \ŊԊuQƂĕ
	else
	{
		// d-SoC\Ŏۂ̊Ԋuĕ
		while((i<VOLTAGE_TABLE_SIZE) && (socval==0))
		{
			if(VoltageTable[0][i] <= inputVoltage)
			{
				socval = VoltageTable[1][i] + (inputVoltage - VoltageTable[0][i]) * ( VoltageTable[1][i-1] - VoltageTable[1][i] ) / (VoltageTable[0][i-1] - VoltageTable[0][i]);
				socval /= 10;	// 0.1%̑%𓾂邽
			}

			i++;
		}
	}

	return socval;
}

/**********************************************************/
/*! \brief dϊ
 *
 * ޼ْl(mA)dɕϊ
 *
 * \return	d(mA)
 */
int16_t ConvertDigitalToCurrent(void)
{
	return BATTCUR_Ticks2mA(BATTCUR_GetOffsetCalibratedCurrent());
}

/**********************************************************/
/*! \brief dϊ
 *
 * ޼ْldrRœd(mV)ɕϊ
 *
 * \return	d(mV)
 */
int16_t ConvertDigitalToVoltage(void)
{
	int32_t temp;

	temp = ConvertDigitalToCurrent();
	temp *= INTERNAL_BATT_RESISTOR_TIMES_128;

	if(temp < 0) {
		temp = -temp;
		temp += 64;		// ۂ
		temp >>= 7;		// 128ŏZ
		temp = -temp;
	} else {
		temp += 64;		// ۂ
		temp >>= 7;		// 128ŏZ
	}

	return ((int16_t) temp);
}
