/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief 
 *		ʐM̧قSMBus疽߂ǂSBSwްR/Wƒ𑗂܂B
 *
 * \par pLq:
 *		AVR456: SB201 HVA 1,2ٌdŗѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $ \n
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include "common.h"
#include "sw_uart.h"
#include "communication.h"
#include "SBS_commands.h"
#include "crc8.h"

/* ϐ */
COMM_States_t COMM_State;
uint8_t COMM_CalculatedPEC;
uint8_t COMM_BytesToReceive;
uint8_t COMM_ReceivedBytes;

/*! \brief UARTP
 *
 *  ĳ쓮PUART
 */	
void Comm_Init(void)
{
	SW_UART_Enable();
	COMM_State = COMM_WAITING_FOR_COMMAND;
}

/*! \brief SBSǂݍݖ߂ɕԓ
 *
 *	\param	sbsReply	ް܂#SBS_command_t\̂ւ̈ʒuwq
 */	
void Comm_SbsBlockCommandReply( SBS_command_t* sbsReply )
{
	// ް{̑oPECXV
	for( uint8_t i=0; i < SBSDATA_BLOCK_LENGTH; i++)
	{
		SW_UART_Transmit( sbsReply->payload[i] );
		CRC8_Update(&COMM_CalculatedPEC, sbsReply->payload[i] );
	}
	// PECo
	SW_UART_Transmit( COMM_CalculatedPEC );
}

/*! \brief SBSǂݍݖ߂ɕԓ
 *
 *	\param	sbsReply	ް܂#SBS_command_t\̂ւ̈ʒuwq
 */	
void Comm_SbsWordCommandReply( SBS_command_t* sbsReply )
{
	// ް{̑o
	SW_UART_Transmit( sbsReply->payload[0] );
	SW_UART_Transmit( sbsReply->payload[1] );
	// PEČvZƑo
	CRC8_Update( &COMM_CalculatedPEC, sbsReply->payload[0] );
	CRC8_Update( &COMM_CalculatedPEC, sbsReply->payload[1] );
	SW_UART_Transmit( COMM_CalculatedPEC );
}

/*! \brief 󂯎ߐACKo
 */
void Comm_SendACK()
{
	SW_UART_Transmit( COMM_ACK );
	COMM_State = COMM_WAITING_FOR_COMMAND;
}

/*! \brief ߉
 *
 *  ߂𒲂ׂүނKwpSBS֑܂B
 *
 *  ̊֐0Ԃ(M)ꍇÅ֐ĂьĂ΂Oɏ邱
 *  dvłB
 *
 *  \param	sbsCmdDestination	ްۑꏊ
 *
 *  \return	V߂󂯎ē]ɏՕɓ]ꂽꍇɐ^
*/	
bool Comm_Handle( SBS_command_t* sbsCmdDestination )
{
	bool receiveComplete = false;

	// Ăѐݒ肵čĂт̊֐Ă΂̂߁A\Ȍ葁׸ނ
	CLEAR_FLAG(SW_UART_status, SW_UART_RX_COMPLETE );

	if( READ_FLAG(SW_UART_status, SW_UART_FRAME_ERROR) ) {
		// ڰшُ󂯎ꍇAfƂĈA̖߂҂܂B
		CLEAR_FLAG(SW_UART_status, SW_UART_FRAME_ERROR);
		CLEAR_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW);
		COMM_State = COMM_WAITING_FOR_COMMAND;

	} else if( READ_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW) ) {
		// ɏՕꂪNꍇAf҂܂B
		CLEAR_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW);
		COMM_State = COMM_WAITING_FOR_BREAK;
	} else {

		// ΁AMް
		while( SW_UART_Data_Available() ) {
			if(receiveComplete) {
				// MłARXɏՕɖްꍇAsN
				// ÂɑSĂؾĂĒf҂܂B
				CLEAR_FLAG(SW_UART_status, SW_UART_FRAME_ERROR);
				CLEAR_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW);
				receiveComplete = false;
				SW_UART_Flush_Buffers();
				COMM_State = COMM_WAITING_FOR_BREAK;

			} else if( READ_FLAG(SW_UART_status, SW_UART_FRAME_ERROR) ) {
				// ڰшُ󂯎ꍇAfƂĈA̖߂҂
				// B
				CLEAR_FLAG(SW_UART_status, SW_UART_FRAME_ERROR);
				CLEAR_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW);
				COMM_State = COMM_WAITING_FOR_COMMAND;

			} else if( READ_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW) ) {
				// ɏՕꂪNꍇAf҂܂B
				CLEAR_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW);
				COMM_State = COMM_WAITING_FOR_BREAK;

			} else {
				// Mް擾
				uint8_t data = SW_UART_Getchar();

				switch( COMM_State ) {
				case COMM_WAITING_FOR_BREAK:
					{
						// s܂Bfcase switch̊Oň܂B
						break;
					}
				case COMM_WAITING_FOR_COMMAND:
					{
						// ްM܂B
						CLEAR_FLAG(SW_UART_status, SW_UART_DECLINE_NEW_TX_DATA);
						// ߕۑ
						sbsCmdDestination->command = (SBS_commands_t)data;
						if( data & 0x80 ) {
							// ǂݍݖ
							receiveComplete = true;
							COMM_State = COMM_WAITING_FOR_COMMAND;
						} else {
							// ݖ
							COMM_State = COMM_RECEIVING_DATA;
							COMM_ReceivedBytes = 0;

							// ł͏ݖ߂邽߁A򒲍
							// ɓǂ/ޯĂ苎Kv͂܂B
							if(   SBS_IsCommandStaticStringType((SBS_commands_t)(data))
								 || SBS_IsCommandBlockDataType((SBS_commands_t)(data)) )
							{
								// 򖽗
								COMM_BytesToReceive = SBSDATA_BLOCK_LENGTH ;
							} else {
								// ꖽ
								COMM_BytesToReceive = 2;
							}
						}
						// νĂ֖ߑԂAPEC
						SW_UART_Transmit( data );
						COMM_CalculatedPEC = 0;
						CRC8_Update( &COMM_CalculatedPEC, data);
						break;
					}

				case COMM_RECEIVING_DATA:
					{
						if(COMM_ReceivedBytes == COMM_BytesToReceive) {
							// Sް ޲ĂMAPECłB
							if( data == COMM_CalculatedPEC ) {
								receiveComplete = true;
								// receiveComplete֐͏ݖ߂ɑ
								// ACK𑗂Ȃ΂Ȃ܂B
							} else {
								// PECsȏꍇNACK𑗏o
								SW_UART_Transmit(COMM_NACK);
								COMM_State = COMM_WAITING_FOR_COMMAND;
							}
						} else {
							// M޲ĂMɏՕɒǉAPECXV
							sbsCmdDestination->payload[COMM_ReceivedBytes++] = data;
							CRC8_Update(&COMM_CalculatedPEC, data);
						}
						break;
					}
				} // switch(COMM_state)
			}
		} // while( SW_UART_Data_Available() )
	}

	return receiveComplete;
}

/*! \brief ʐMԒ
 *
 *  ̊֐͐is̒ʐMꍇɐ^Ԃ܂B̌ܰޓւ̈
 *  s͈SłB
 *
 *  \return	ق̏ꍇɐ^AZ̏ꍇɋU
 */
bool Comm_IsIdle(void)
{
	return (0 == SW_UART_counter);
}

/*! \brief ʐMԒ
 *
 *  ̊֐͉ĂȂ0Ԃ܂Bꂪ>0̏ꍇA
 *  Comm_Handle()s
 *
 *  \return	ĂȂꍇ0Aꍇ1
 */
uint8_t Comm_Flag(void)
{
	return SW_UART_status;
}
