/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		x^16+x^15+x^2+1ɂ߂CRCvZp֐܂݂܂B
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include "crc16.h"
#include "ATmega8HVA_16HVA_signature.h"

/****************************
 * CRC-16vZ
 *
 * : x^16 + x^15 + x^2 + 1
 *
 * \param	crc		XVCRC
 * \param	data	CRCXVް
 *
 * \return	V
 */
uint16_t crc16_update(uint16_t crc, uint8_t data)
{
	crc ^= data;
	for (uint8_t i = 0; i < 8; ++i)
	{
		if (crc & 1) {
			crc = (crc >> 1) ^ 0xA001;
		} else {
			crc >>= 1;
		}
	}

	return crc;
}

/*!
 * [тɎg鲽״ رCRC16
 */
uint16_t crc16_from_atmel(uint16_t crc, uint16_t data)
{
	uint8_t data_bit;
	uint8_t crc_msb;

	for(int8_t bit = 15; bit >= 0; --bit) {
		data_bit = (data >> bit) & 1;
		crc_msb = (crc >> 15) & 1;
		crc = (((crc <<1)+ data_bit) ^ (crc_msb << 15) ^ (crc_msb << 2) ^ (crc_msb << 0));
	}

	return crc;
}

/*! \brief [ްCRC
 *
 * \retval	true	CRC͐łB
 * \retval	false	CRC͐܂B
 */
bool CheckSignatureCRC()
{
	uint16_t crc = 0;		// ̎ɑ΂Jnl0łB

	uint8_t addr;
	uint16_t data;
	uint8_t data_l;

	for(addr = 0; addr <= 0x1D; ++addr) {
		data_l = READ_SIGNATUREBYTE((void __flash*)(addr*2));
		__delay_cycles(5);
		data = data_l | (READ_SIGNATUREBYTE((void __flash*)(addr*2+1)) << 8);
		crc = crc16_from_atmel(crc, data);
	}

	uint8_t crc_ft_l = READ_SIGNATUREBYTE(SIG_CRC16_FT_L);
	__delay_cycles(5);
	uint16_t correct_crc = crc_ft_l | (READ_SIGNATUREBYTE(SIG_CRC16_FT_H) << 8);

	if(correct_crc == crc) {
		return true;
	} else {
		return false;
	}
}
