/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief 
 *		ATmega16HVA(1܂2ق )drpp
 *		PUART޽SBSߊǗ
 *
 * \par pLq:
 *		AVR456: SB201 HVA 1,2ق̌dŗѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: 2884 $
 * $Date		: 2007N1212 18:38:15 +0100 (on, 12 des 2007) $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include "common.h"
#include "ATmega8HVA_16HVA_signature.h"
#include "bandgap.h"
#include "vadc.h"
#include "ccadc.h"
#include "communication.h"
#include "authentication.h"
#include "battery_protection.h"
#include "battery_pack_parameters.h"
#include "battery_voltage_monitoring.h"
#include "battery_current_monitoring.h"
#include "fet_control.h"
#include "watchdog.h"
#include "rc_calibration.h"
#include "pwr_mgmnt.h"
#include "ntc_rh163h103f.h"
#include "rtc.h"
#include "cc_gas_gauging.h"
#include "gas_gauging.h"
#include "vreg_mon.h"
#include "voltage_based_SoC.h"
#include "crc16.h"

/******************************************************************************
 َ̧ϐ
*******************************************************************************/
//! 0.1݂ł̓߉x
static uint16_t coreTemperature = DEGREES_C_TO_K( 70 dC);
#if CELLTEMPERATURE_INPUTS != 0
//! NTC(н)xi[邽߂̔z
static uint16_t cellTemperature[CELLTEMPERATURE_INPUTS];
#endif
//! ŌɌvZꂽᑬRCi[邽߂̕ϐ
static volatile uint16_t slowRcOscillatorPeriod = SLOW_RC_NOMINAL_PERIOD;
//! ʐMėүނ܂ލ\
SBS_command_t sbs;
SBS_command_t *sbsReply;

//! ُ׸
struct {
	uint8_t criticalConditionDetected	: 1;
	uint8_t cellTemperatureTooLow		: 1;
	uint8_t cellTemperatureTooHigh		: 1;
	uint8_t voltageTooHigh				: 1;
	uint8_t voltageTooLow				: 1;
	uint8_t reoccuringChargeProtection	: 1;
	uint8_t checksumFailure				: 1;
} errorFlags = {0,0,0,0,0,0,0};

//! ׸
struct {
	uint8_t systemIsInStandby			: 1;	//!< dbattParams.activeCurrentThresholdł̒`Ⴂɐݒ
	uint8_t inDUVR						: 1;	//!< nŐݒ肳ADUVR삪֎~鎞ɉ
	uint8_t chargingProhibited			: 1;	//!< [d͕ddo܂ŋ֎~܂B
	uint8_t dischargingProhibited		: 1;	//!< d͏[ddo܂ŋ֎~܂B
	uint8_t simulatePowerOff			: 1;	//!< ݂ܰ̂鎞ɐݒ肳܂A֎~܂(ޯގɎg꓾܂)B
	uint8_t remainingCapacityInaccurate	: 1;	//!< remainingCapacitySoCɊÂd琄肳ꂽSoCɊÂꍇ1ɐݒ
	//! ̏ꍇ: ܰ̏ɐݒ
	//! ݒ̏ꍇ: ׸ސݒŐVܰ̏ꍇA޲ܰ̂ɈڍsB
	//!				ܰ̂oȂꍇA׸ނ܂B
	//! HZƒZdWłܰ̈ڍŝɎg܂B
	uint8_t poweroffCondition : 1;
} stateFlags = {0,0,0,0,0,0,0};

struct {
	uint8_t remainingCapacityAlarm		: 1;	//!< ceʂbattParams.remainingCapacityAlarmŐݒ肳ꂽxlႢɐݒ(1xXV)
	uint8_t remainingTimeAlarm			: 1;	//!< ϓdł̎c莞ԂbattParams.remainingTimeAlarmł̌xlႢɐݒ(1xXV)
	uint8_t terminateDischarge			: 1;	//!< d\Ȍ葬IׂɐݒB[ddoꂽɉ
	uint8_t fullyCharged				: 1;	//!< S[dɐݒAddʒmꂽɉ
	uint8_t fullyDischarged				: 1;	//!< ceʂ0ȉ̎ɐݒASoC20%ȏ̎ɉB܂Ad̂߁AdFET܂B

	uint8_t forceChargeFETDisabled		: 1;	//!< [dFET֎~
	uint8_t forceDischargeFETDisabled	: 1;	//!< dFET֎~
} sbsFlags = {0,0,0,0,0,0,0};

//! ׸
struct {
	uint8_t newCurrentAvailable			: 1;	//!< VCCADCACCʂ͏鏀܂B
	uint8_t rcCalibrationRequired		: 1;	//!< ꂪݒ肳ꂽꍇARC̍čZKvƂʁAxς܂B
	uint8_t newSbsCommandAvailable		: 1;	//!< ꂪݒ肳ꂽꍇAʐM̪SүނM܂B
	uint8_t doAuthentication			: 1;	//!< ꂪݒ肳ꂽꍇAʐM̪Fؖ߂M܂B
} taskFlags = {0,0,0,0};

/******************************************************************************
 I֐p^錾
******************************************************************************/
err_t Reset_Initialization();

void runEverySecond();
void runEveryMinute();

static void handleNewCoreTemperature();
static void handleNewCellTemperature();
static int8_t checkBatteryTemperature(int16_t temperature, bool discharge);
static void handleNewCell1Voltage();
#if BATTPARAM_CELLS_IN_SERIES >= 2
static void handleNewCell2Voltage();
#endif

static void handleNewCCADCResult();
static void configureVADC();

static void disableDUVRIfPossible();
static bool anyTemperatureError();

static void enterPoweroff();

static void handleSBSCommand();

/******************************************************************************/
/*! \brief ֐
 *
 * ͉pLqŋLq鏉ƎJԂ܂݂܂B荞ݏٰ(ISR)
 * JԂŏSĂް܂B
 */
int main( void )
{
	/*
	Ӌ@\Pʕ̏:
	- ޯ(ԂCC-ADCŎgŒƒȂ΂Ȃ܂B)
	- svPʕOFF(SPÎ)
	- ޷ެ
	- dی쐅/\ݒ
	- V-ADC
		- ٓd擾(荞݂邱ƂKvƂ܂B)
		- x擾
		- eʐ("Rv")
	- drdׂ޲DUVR삩
	- CC-ADC
		- dl擾(uƕ)
	- ʐM
	*/
	// 
	WDT_ResetTimer();

	WDT_SetTimeOut( WDTO_2Kms );	// ޯސԂ2bɐݒ

#ifdef DEBUG
	if( FAILURE == Reset_Initialization() ){
		// ׂ: ޯނN܂B - dr̎Ւf]ނ܂?!B
		// POWMAN_Shutdown();
	}
#endif

	PRR_DISABLE_SPI();										// SPIɑ΂ēd͍팸
	DIDR0 = (1<<PA0DID) | (1<<PA1DID);						// ߰Aɑ΂޼ٓ͂֎~
	PORTB = (1<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB3);		// ݂邽߁A߰Bɑ΂ٱ߂

	// drҰ\̂CRCђ
	errorFlags.checksumFailure = (! BATTPARAM_CheckCRC()) | (! CheckSignatureCRC());

	// ޷ެߎQƊ
	if( FAILURE == BANDGAP_Initialization() ){
		errorFlags.criticalConditionDetected = true;
	}

	// drیPʕ(ŋ - ݒŗǂȂ炱͕sv)
	BATTPROT_SetShortCircuitDetection( battParams.shortcircuitCurrent, battParams.shortcircuitReactionTime );
	BATTPROT_SetOverCurrentDetection( battParams.overcurrentCharge, battParams.overcurrentDischarge, battParams.overcurrentReactionTime );
	BATTPROT_SetHighCurrentDetection( battParams.highcurrentCharge, battParams.highcurrentDischarge, battParams.highcurrentReactionTime );

	BATTPROT_DisableDischargeHighCurrentProtection();	// (̗ł)FET֎~邽߂̕dd͖]݂܂B
	BATTPROT_EnableAllInterrupts();

	stateFlags.inDUVR = true;							// ؾĂ޲͏DUVRłB

	VREGMON_InterruptEnable();							// dĎ荞݂

	// V-ADCAS\ݒ
	VADC_InitializeVadcCoefficients();
	VADC_ScanConfig( (vadcIndex_t)HIGHEST_CELL, (vadcIndex_t)HIGHEST_VADC, (vadcIndex_t)VTEMP );

	// VADCScanConfigŐݒ肳ꂽꍇɂs܂B
	if( FAILURE == VADC_StartScan() ){ 
		errorFlags.criticalConditionDetected = true;
	} else {
		__enable_interrupt();
		while( VADC_RUNNING == VADC_ScanState() );
		__disable_interrupt();

		VADC_ClearReadyFlags();

		disableDUVRIfPossible();
		VBSoC_Init();
	}

	// mAւccadc_ticksmAhւgas_gauging̊֐ɑ΂"@"vZ
	BATTCUR_CalculateMagicNumber(battParams.shuntResistance);
	CCGASG_CalculateMagicalNumbers(battParams.shuntResistance);

	// SRAMdrҰ\̗p̒lvZ
	BATTPARAM_InitSramParameters();

	// AESgꍇAEEPROMSRAM֌𕡎
#if defined(AUTH_USE_AES)
	AUTH_CopyKeyToSram();
#endif

	// dvȏ(޷ެ߂ĂȂA܂VADCsɍ\ݒ肳ꂽ̂ǂ炩)NꍇA
	// dr֘Âǂs킸ADUVR֎~(̂ɏ[d͕s\)
	if( errorFlags.criticalConditionDetected ) {
		FETCTRL_DisableDeepUnderVoltageMode();
		FETCTRL_DisableFets();

	} else {
		// CC-ADC(bɍ̎Adݒ)
		CCADC_Init( ACCT_1024, RCCI_1024, 10 mA );
		CCADC_SetMode( CCADC_ACC );

		// CCGASGPʕ̏ceʂݒA͕smƂċLAmȑlŏVBSoCōXV܂B
		CCGASG_SetStateofCharge(VBSoC_EstimatedSoC());
		stateFlags.remainingCapacityInaccurate = 1;

		__enable_interrupt();
		// l̂ɐ旧ĕϊ𑖍s邱ƂKv
		while( !CCADC_isAccResultReady() );
		WDT_ResetTimer();
		__disable_interrupt();

		// ꂪȂCCADCݐϕϊψ(̾)vZDUVR삪֎~܂B
		if(CCADC_GetRawAccOffset() == 32767 && ! stateFlags.inDUVR) {
			FETCTRL_DisableFets();		// ψʑ莞AdωǂȂ߁AFET֎~
			__enable_interrupt();
			CCADC_CalculateAccOffset();
			__disable_interrupt();
		}

		// 2ȏ̾ق̏ꍇAstC
#if BATTPARAM_CELLS_IN_SERIES >= 2
		BATTVMON_InitializeBalancing();
#endif

		// (νĂ̖₢ɕԓ)dɂĂ̏i[
		BATTCUR_StoreCurrent( CCADC_GetAccResult() );
		BATTCUR_InitializeAverageCurrent( BATTCUR_GetOffsetCalibratedCurrent() );
	}

	// ʐM޽
	Comm_Init();

	// s - 荞݋ĎJԂֈڍs
	__enable_interrupt();

	/*******************************************************************
	JԂ:
	׸ނ̂ǂꂩݒȂAΉƂsׂłB

	ȉ̂ƂN܂B:
	- ޯ ؾ
	- VCCADCʂȂAVADCϊJn
	- ʐM̪V޲ĂȂA
	- ĐVߑŜȂA
	- VCCADCʂȂA
	- ȂAVx𒲂ׁAKvȂ΍RCZ𑖍s
	- ȂAVىx𒲍
	- ȂAVٓd𒲍
	- sĂ邩ɉĊex~ݒ
	  - ʐM܂RCZ(ꂩ̌v푖s)ȂAٓɂڍs邱Ƃł܂B
	  - VADCsȂAADCGጸ[֍sƂ͂ł܂B
	  - sĂȂ΁AܰނɈڍs܂B
	- lXȂƂɉFET֎~/
	- x~H֍s܂B
	*/
	while(1) {
		/* 
		񳫯ޯނ𖞑܂B
		*/
		WDT_ResetTimer();

		if( CCADC_isAccResultReady() )
		{
			// Ăт̎邽߁AJԂIOɂłΑSĂ̑ł悤ɉ\Ȍ葬VADCJn

			// ق̏ꍇɾٕt֎~
#if BATTPARAM_CELLS_IN_SERIES >= 2
				BATTVMON_DisableCellBalancing();
#endif

			// VKVADCJn
			configureVADC();
			VADC_StartScan();

			taskFlags.newCurrentAvailable = true;
		}

		// MɏՕł޲đ҂
		if( Comm_Flag() ){
			// ޲ĂMASSBS߂Mꂽ𔻒f邽߂ɒʐMĂ΂܂B
			taskFlags.newSbsCommandAvailable = Comm_Handle( &sbs );
		}

		/*
		SSBS߂MꂽȂA
		*/
		if( taskFlags.newSbsCommandAvailable )
		{
			handleSBSCommand();
			// F؂KvƂꍇAsBSBS̒lgĕύXAʐM荞݂ڂȂƂۏ؁B
			// ͒Ԃ邩ꂸA̎Ԃ̊ԁAʐMȂƂɒӂĂB
			if(taskFlags.doAuthentication) {
				AUTH_Execute(&sbs);
				taskFlags.doAuthentication = false;
			}
		}

		/* 
		VCC-ADCϊp\BudAϓdXVĐVdreʂvZB
		discharge_cycle_accumulatorXV(AKvƂꍇcycle_count𑝉B
		*/
		if( taskFlags.newCurrentAvailable )
		{
			taskFlags.newCurrentAvailable = false;

			// RTCpvƂCCADC荞݂gp
			runEverySecond();
			BATTCUR_StoreCurrent( CCADC_GetAccResult() );
			handleNewCCADCResult();
			CCGASG_AccumulateCCADCMeasurements( BATTCUR_GetCurrent(), slowRcOscillatorPeriod );
		}

		/*
		VxlpŏׂłBxύXꂽꍇA
		RC_calibration_required׸ނݒ
		*/
		if( VADC_VTempReady() )
		{
			handleNewCoreTemperature();
		}

		/*
		RCU͍ZKvƂ܂(VCC_ADCϊԂvZĊi[ׂł)B
		*/
		if( taskFlags.rcCalibrationRequired )
		{
			taskFlags.rcCalibrationRequired = false;
			RCCAL_StartCalibrateFastRC();

			// ݑŜœhRCvZ
			slowRcOscillatorPeriod = RCCAL_CalculateSlowRCperiod( coreTemperature/10 );
		}

		if( RCCAL_GetState() == RCCAL_CALIB_INIT || RCCAL_GetState() == RCCAL_CALIB_WORKING ) {
			RCCAL_CalibrateFastRCruntime(slowRcOscillatorPeriod);
		}

		/*
		drىxp\B𒲂ׂč/Ⴗ̏ꍇFET֎~
		*/
		if( VADC_CellTempReady() )
		{
			handleNewCellTemperature();
		}

		/*
		drٓdB厖(/d)
		*/
		if( VADC_Cell1VoltageReady() )
		{
			handleNewCell1Voltage();
		}

		/*
		drٓdB厖(/d)ƕst
		*/
#if BATTPARAM_CELLS_IN_SERIES >= 2
		if( VADC_Cell2VoltageReady() )
		{
			handleNewCell2Voltage();
		}
#endif

		// ǂ̋x~ֈڍsł邩BȂ΁A荞݂SMCR㏑邩
		// ߁A荞݂̋֎~Kv(Ⴆ΁AO荞݂NıقȂx~
		// ]ޏꍇASĂ̌ɑׂł)B
		uint8_t interruptState = __save_interrupt();
		__disable_interrupt();
		if( Comm_IsIdle() && ! RCCAL_IS_RUNNING() ) {
			if( VADC_RUNNING == VADC_ScanState() ) {
				SLEEP_SET_ADC_NR_MODE();
			} else {
				SLEEP_SET_POWER_SAVE_MODE();
			}
		} else {
			SLEEP_SET_IDLE_MODE();
		}
		__restore_interrupt(interruptState);

		/*
		dȏ󋵂SYʂꂽꍇFET֎~
		xd̂悤ȗlXȗvfɉĂꂪOKȂ΂
		*/
		if(   errorFlags.criticalConditionDetected
			 || stateFlags.simulatePowerOff)
		{
			FETCTRL_DisableFets();
		}
		else if( ! errorFlags.cellTemperatureTooHigh &&
		         ! errorFlags.cellTemperatureTooLow &&
		         ! stateFlags.inDUVR)
		{
			if(   ! errorFlags.voltageTooHigh 
			   && ! errorFlags.reoccuringChargeProtection
			   && ! stateFlags.chargingProhibited
			   && ! sbsFlags.forceChargeFETDisabled) 
			{
				FETCTRL_EnableChargeFet();
			}
			
			if(   ! errorFlags.voltageTooLow
			   && ! stateFlags.dischargingProhibited
			   && ! sbsFlags.forceDischargeFETDisabled)
			{
				FETCTRL_EnableDischargeFet();
			}
		}

		// sR͉HZžٓdlsɂȂ蓾AchargingProhibited
		// dischargingProhibited̗׸ނ̐ݒ肪NꍇɂsȂA炪ĉ
		// ȂłB炪ݒ肳ׂꍇA͎̎FETĂыO
		// Ăѐݒ肳ł傤B
		if( stateFlags.chargingProhibited && stateFlags.dischargingProhibited ) {
			stateFlags.chargingProhibited = false;
			stateFlags.dischargingProhibited = false;
		}

		// ʐMŒPɐV޲ĂMĂȂꍇɋx~ֈڍsBComm_Flag__sleep̌̊Ԃ
		// ޲ĂMꂽꍇAĳUART荞݂x~싖邽߁Ax~֐͖łB
		if( Comm_Flag() == 0 ) {
			__sleep();
		}
	}
}

/******************************************************************************/
/*! \brief ޯޏ
 *
 * ޯ  ؾĂNAȂAv킪₳܂BWSRv
 * WDR_LIMITɒBꍇAт񂩎sƂƁAĊJȂl
 * ȂƂ߂ɎsԂ܂BWSRvPOR܂BOD̉ꂩ
 * ؾĂNꍇؾĂ܂B
 *
 *	\retval	err_t	WSRv킪xʉ߂ĂȂꍇɐ^AȂ΋VԂ܂B
 */
err_t Reset_Initialization()
{
	uint8_t reset_flags;

	/* ؾ ׸ނ̓ǂݎƉ */
	reset_flags = MCUSR;				// ؾ ׸ނۑ
	MCUSR       = 0;					// ȑOɐݒ肳ꂽSĂ׸ނ

	/* ؾ ׯނݒ肳ĂȂꍇA\ނͱڽ0ɖ߂܂B */
	if( reset_flags == 0 )
	{
		__disable_interrupt();
		// ]ޏꍇÄُ邽߂̺ނɒǉ邱Ƃł܂B
		for(;;);						// ޯސԂ𒴉߂Aޯ  ؾĂ𔭐
	}

	/* ޯ  ؾČ */
	if( reset_flags & (1<<WDRF) )
	{
		wdr_count++;					// ޯ  ؾČv𑝉

		/* ޯ  ؾĘA𒴂? */
		if( wdr_count >= WDR_LIMIT )
		{
			return FAILURE;				// ُүނ𑗂Ԃ
		}
	}

	/* ʓd܂͊OؾĂųޯ  ؾČv */
	if( reset_flags & (1<<PORF) || reset_flags & (1<<EXTRF) )
	{
		wdr_count = 0;
	}

	return SUCCESS;
}

/******************************************/
/*! \brief bɂ̊֐𑖍s
 *
 * - RTCXVrunEveryMinute֐
 * - ߏ[dN
 */
#pragma inline=forced
void runEverySecond() {	
	// RTCXV
	// VȂ^ԂAȂ΂̊֐𑖍s
	if( RTC_AddSecond() ) {
		runEveryMinute();
	}

	/*
	drی슄荞݂BATTPROT_REOCCURING_CHARGE_PROTECTION_GAPbԋNĂȂꍇA
	chargeProtectionCounter(׸ނ͕ddoꂽɐݒ肳܂)B
	ꂪNČv킪xz̏ꍇAreoccuringChargeProtection׸ނݒ
	*/
	static uint8_t reoccuringChargeProtectionGapCounter = 0;
	if( BATTPROT_IsProtectionTriggered() ) {
		if( BATTPROT_GetChargeProtectionCounter() >= BATTPROT_REOCCURING_CHARGE_PROTECTION_LIMIT ) {
			errorFlags.reoccuringChargeProtection = true;
		}
	} else {
		if(BATTPROT_GetChargeProtectionCounter() != 0) {
			++reoccuringChargeProtectionGapCounter;
			if(reoccuringChargeProtectionGapCounter >= BATTPROT_REOCCURING_CHARGE_PROTECTION_GAP) {
				BATTPROT_ClearChargeProtectionCounter();
				reoccuringChargeProtectionGapCounter = 0;
			}
		}
	}
}

/*! \brief ɂ̊֐𑖍s
 *
 * ceʂƎԌxXV
 * KvƂꍇterminateDischargefullyDischargeXV
 */
#pragma inline=forced
void runEveryMinute() {
	// ceʂƎԌxXV
	// 炪0ɐݒ肳ꍇAx񂪋֎~܂B
	if(   battParams.remainingCapacityAlarm != 0
		 && CCGASG_Acc2mAh(CCGASG_ReadAccumulatedCC()) < battParams.remainingCapacityAlarm)
	{
		sbsFlags.remainingCapacityAlarm = true;
	} else {
		sbsFlags.remainingCapacityAlarm = false;
	}

	if(   battParams.remainingTimeAlarm != 0
		 && GASG_TimeToEmpty( BATTCUR_GetAverageCurrent() ) < battParams.remainingTimeAlarm)
	{
		sbsFlags.remainingTimeAlarm = true;
	} else {
		sbsFlags.remainingTimeAlarm = false;
	}

	// SBSI׸ނ⊮Sd׸ނݒ肳ׂ
	int32_t remCap = GASG_RemainingCapacity(BATTCUR_GetAverageCurrent());
	if( remCap < battParams_sram.terminateDischargeLimit ) {
		sbsFlags.terminateDischarge = true;

		if( remCap <= 0 ) {
			sbsFlags.fullyDischarged = true;
		}
	}
}

/***********************************/
/*! \brief Vx
 *
 * xςꂽꍇARCčZKvƂ܂B
 *
 * x߂̓ɑ΂č/Ⴗ̏ꍇAܰ̂ֈڍs
 *
 * dr̉xp̻нȂꍇAdrxɺxg܂B
 */
static void handleNewCoreTemperature() {
	int16_t newCoreTemperature = VADC_readSystemTemperature( );

	// xCORE_TEMPERATURE_CHANGE_THRESHOLDύXꂽꍇAʐM삷̂ƁA
	// CC-ADClmȂƂۏ؂邽߂RCU͍ZKvłB
	if( (coreTemperature + CORE_TEMPERATURE_CHANGE_THRESHOLD) <= newCoreTemperature ||
		 (coreTemperature - CORE_TEMPERATURE_CHANGE_THRESHOLD) >= newCoreTemperature )
	{
		coreTemperature = newCoreTemperature;
		taskFlags.rcCalibrationRequired = true;
	}

	// x߂ɑ΂ē͈͊ȌꍇAܰ̂ֈڍs
	if( coreTemperature >= CORE_MAX_TEMPERATURE || coreTemperature <= CORE_MIN_TEMPERATURE ) {
		// x: sSȒl邽߁Aܰ̂̑Oɑ2xN邱Ƃ𒲍
		enterPoweroff();
	}

	// нgȂɺxdrxƓƉ
#if HIGHEST_VADC == 0
	if( ! stateFlags.systemIsInStandby || anyTemperatureError() ) {
		if (checkBatteryTemperature(newCoreTemperature, BATTCUR_IsDischargeOngoing() ) ) {
			errorFlags.cellTemperatureTooHigh = false;
			errorFlags.cellTemperatureTooLow = false;
		}
	}
#endif
}

/***********************************/
/*! \brief Vىx
 *
 * xAႷ̏ꍇFET֎~
 *
 * ޲(ɒႢd̗)̏ꍇA/Ⴗ̉x܂(Agp
 * ǂނƂł悤ɂƂɂxǂ݂܂)B
 */
static void handleNewCellTemperature() {

	// н\ݒ肳ȂꍇÅ֐͌ČĂ΂ׂł͂܂
	// AŜ߁AƂɂs܂B
#if HIGHEST_VADC == 0
		return;

#else
		uint16_t battCellTempVoltage = VADC_readVadc( VADC0 );
		cellTemperature[0] = NTC_ReadTemperatureKelvin(battCellTempVoltage);

#if HIGHEST_VADC == DEF_VADC1
		battCellTempVoltage = VADC_readVadc( VADC1 );
		cellTemperature[1] = NTC_ReadTemperatureKelvin(battCellTempVoltage);
#endif

		if( ! stateFlags.systemIsInStandby  || anyTemperatureError() ) {
			bool discharge = BATTCUR_IsDischargeOngoing();
			bool allOK = checkBatteryTemperature(cellTemperature[0], discharge);

			// \ݒ肳ĂčŏOKȂA2ڂ̻н𒲍B1̓drɌxȌꍇ͕sv
#if HIGHEST_VADC == DEF_VADC1
			{
				if( allOK ) {
					allOK = checkBatteryTemperature(cellTemperature[1], discharge);
				}
			}
#endif //HIGHEST_VADC == DEF_VADC1

			// SẲxOKȂA׸ނSɐݒ
			if( allOK ) {
				errorFlags.cellTemperatureTooHigh = false;
				errorFlags.cellTemperatureTooLow = false;
			}
		}
#endif // else from HIGHEST_VADC == 0
}

/**************************/
/*! \brief drxx
 *
 * \param	temperature	(0.1݂ł)ׂ鉷x
 * \param	discharge	drdȂΐ^Adr[dȂ΋U
 *
 * \retval	true		drx͌x
 * \retval	false		drx͌xOBΉFET֎~܂B
 */
static int8_t checkBatteryTemperature(int16_t temperature, bool discharge) {
	bool ret = true;

	if( discharge ) {
		if( battParams.cellMaxDischargeTemperature < temperature ) {
			FETCTRL_DisableDischargeFet();
			errorFlags.cellTemperatureTooHigh = true;
			ret = false;

		} else if( battParams.cellMinDischargeTemperature > temperature ) {
			FETCTRL_DisableDischargeFet();
			errorFlags.cellTemperatureTooLow = true;
			ret = false;
		}
	} else {
		if( battParams.cellMaxChargeTemperature < temperature ) {
			FETCTRL_DisableChargeFet();
			errorFlags.cellTemperatureTooHigh = true;
			ret = false;

		} else if( battParams.cellMinChargeTemperature > temperature ) {
			FETCTRL_DisableChargeFet();
			errorFlags.cellTemperatureTooLow = true;
			ret = false;
		}
	}
	return ret;
}

/***********************************/
/*! \brief 1ٗpVٓd
 *
 * - Pق̉pȂADUVR֎~s
 * - Pق̉pȂASoCɊÂdXV
 * - ٓdႷŕd̏ꍇAdFET֎~A[ddo܂ŋ܂B
 * - ٓdꍇA[dFET֎~Addo܂ŋ܂B
 */
static void handleNewCell1Voltage() {
#if BATTPARAM_CELLS_IN_SERIES == 1
	disableDUVRIfPossible();
	// d(SoC)ɊÂdXVBb1񑖍sƉBVOCV SoCꂽꍇɐ^ԂA
	// ̂ɂꂪsmƌ􂳂ꂽꍇɐVremainingCapacityvZ܂B
	if(VBSoC_Update() && stateFlags.remainingCapacityInaccurate) {
		CCGASG_SetStateofCharge(VBSoC_OCSoC());
		stateFlags.remainingCapacityInaccurate = false;
	}
#endif

	bool discharge = BATTCUR_IsDischargeOngoing();

	// voltageTooHighvoltageTooLow׸ނB͂̊֐܂handleNewCell2Voltage
	// ̂ǂ炩ɂĐݒ肷邱Ƃł܂A׸ނPhandleNewCell1VoltageɂĐݒ肳
	// m邱ƂłȂ߁AhandleNewCell2Voltageɂĉ邱Ƃł܂B
	errorFlags.voltageTooLow = false;
	errorFlags.voltageTooHigh = false;

	// drddlł邱Ƃ𒲍 - łȂꍇ͏[dFET֎~
	if( discharge && BATTVMON_IsCellVoltageTooLow(CELL1) )
	{
		stateFlags.dischargingProhibited = true;
		FETCTRL_DisableDischargeFet();
		errorFlags.voltageTooLow = true;

		sbsFlags.fullyDischarged = true;

		// dႷ鎞ɂ͂܂ܰ̂Ɉڍsׂقǂ̒Ⴓ܂BA
		// handleNewCell2Voltageق𒲂ׂ邽߁Ał1قœĂ鎞ɂB
		// ~(Ւf)ɂ͑2ܰ̂KvƂ܂Bܰ̂ȂꍇA
		// enterPoweroff()simulatePowerOffRequireݒ肵FET֎~܂B
#if BATTPARAM_CELLS_IN_SERIES == 1
		if(VADC_readCellVoltage(CELL1) <= battParams.cellPoweroffVoltage) {
			if( stateFlags.poweroffCondition ) {
				enterPoweroff();
			} else {
				stateFlags.poweroffCondition = true;
			}
		} else {
			stateFlags.poweroffCondition = false;
		}
#endif

	}

	if( !discharge &&  BATTVMON_IsCellVoltageTooHigh(CELL1) ) {
		stateFlags.chargingProhibited = true;
		FETCTRL_DisableChargeFet();
		errorFlags.voltageTooHigh = true;
	}
}

/***********************************/
/*! \brief 2ٗpVٓd
 *
 * - DUVȐꍇɂ֎~
 * - (1dłg)SoCɊÂdXV
 * - ٓdႷŕd̏ꍇAdFET֎~A[ddo܂ŋ܂B
 * - ٓdꍇA[dFET֎~Addo܂ŋ܂B
 * - ٕtׂ
 */
#if BATTPARAM_CELLS_IN_SERIES >= 2
static void handleNewCell2Voltage() {
	disableDUVRIfPossible();

	// d(SoC)ɊÂdXVBb1񑖍sƉBVOCV SoCꂽꍇɐ^ԂA
	// ̂ɂꂪsmƌ􂳂ꂽꍇɐVremainingCapacityvZ܂B
	if(VBSoC_Update() && stateFlags.remainingCapacityInaccurate) {
		CCGASG_SetStateofCharge(VBSoC_OCSoC());
	}

	bool discharge = BATTCUR_IsDischargeOngoing();

	// drddlł邱Ƃ𒲍 - łȂꍇ͏[dFET֎~
	if( discharge && BATTVMON_IsCellVoltageTooLow(CELL2) )
	{
		stateFlags.dischargingProhibited = true;
		FETCTRL_DisableDischargeFet();
		errorFlags.voltageTooLow = true;

		sbsFlags.fullyDischarged = true;

	} else if( !discharge )
	{
		// DUVRłȂξٕt
		if( ! stateFlags.inDUVR ) {
			BATTVMON_EnableCellBalancing();
		}

		// d
		if( BATTVMON_IsCellVoltageTooHigh(CELL2) ) {
			stateFlags.chargingProhibited = true;
			FETCTRL_DisableChargeFet();
			errorFlags.voltageTooHigh = true;
		}
	}

	if( errorFlags.voltageTooLow && discharge ) {
		// dႷ鎞ɂ͂܂ܰ̂Ɉڍsׂقǂ̒Ⴓ܂B
		// ~(Ւf)ɂ͑2ܰ̂KvƂ܂Bܰ̂ȂꍇA
		// enterPoweroff()simulatePowerOffRequireݒ肵FET֎~܂B
		if(   VADC_readCellVoltage(CELL2) <= battParams.cellPoweroffVoltage 
		   || VADC_readCellVoltage(CELL1) <= battParams.cellPoweroffVoltage )
		{
			if( stateFlags.poweroffCondition ) {
				enterPoweroff();
			} else {
				stateFlags.poweroffCondition = true;
			}
		} else {
			stateFlags.poweroffCondition = false;
		}
	}
}
#endif

/***********************************************/
/*! \brief CC-ADC̐Vʂ
 *
 * - ϓdXV
 * - ޲ۂm܂B
 * - SoCɊÂdpxvؾ
 * - (Ȃ)d̏ꍇA̕dی𒲂ׂKv͂܂B
 * - KvƂȂAS[deʂXV
 */
static void handleNewCCADCResult() {
	int32_t offsetCompensatedCurrent = BATTCUR_GetOffsetCalibratedCurrent();

	BATTCUR_UpdateAverageCurrent( offsetCompensatedCurrent );

	// ޲ ׸ސݒ
	// [dd璲
	// ޲޲łȂ΁ARvɊÂdpxvؾ
	if( BATTCUR_IsCurrentLow(offsetCompensatedCurrent) )
	{
		stateFlags.systemIsInStandby = true;
	}
	else
	{
		stateFlags.systemIsInStandby = false;

		// xvؾ
		VBSoC_ResetTimer();

		// (޲dłȂ)d̏ꍇA[dی׸ނ
		// ĊS[dޯĂ
		if( BATTCUR_IsDischargeOngoing() ) {
			errorFlags.reoccuringChargeProtection = false;
			stateFlags.chargingProhibited = false;

			sbsFlags.fullyCharged = false;

		// [dAd͂֎~ĂȂƂmF
		// dł̏[d̏ꍇAsĂB
		} else {
			stateFlags.dischargingProhibited = false;

			// [dڑνĂĂѓd͈oJn邽߁AterminateDischarge
			sbsFlags.terminateDischarge = false;
		}
	}

	// [dAdrSɏ[dꂽ
	// ׂ: ͏[d킪dł̏[dړȈꍇ葽̓dz̔\͂Ȃꍇɕs
	//			   łB
	// ܂AfullyDischarged׸ނ꓾邩𒲍
	if( offsetCompensatedCurrent > 0 ) {
		if( sbsFlags.fullyDischarged && GASG_StateOfCharge(offsetCompensatedCurrent, battParams_sram.capacityInCCAccumulated) >= 20 ) {
			sbsFlags.fullyDischarged = false;
		}

		// : Œd̎gp͏[d~̉\𑝂܂Aٕst̂߂ɊS[dƌ􂳂܂
		//	   BA͂炭]ނ̂łB
		uint16_t lowestVoltage;
#if BATTPARAM_CELLS_IN_SERIES == 1
		{
			lowestVoltage = VADC_readCellVoltage( CELL1 );
		}
#elif BATTPARAM_CELLS_IN_SERIES == 2
		{
			uint16_t cell1 = VADC_readCellVoltage( CELL1 );
			uint16_t cell2 = VADC_readCellVoltage( CELL2 );
			lowestVoltage = cell1 < cell2 ? cell1 : cell2;
		}
#endif

		// drS[dƌ􂳂ꂽꍇAfullChargeCapacityXV
		// ׂ: remainingCapacityZ\XV
		// ͏[dɂsÂɌvZӖ܂B
		if( lowestVoltage > battParams.fullChargeVoltage ) {
			if( BATTCUR_mA2Ticks( battParams.fullChargeCurrent ) > offsetCompensatedCurrent ) {
				sbsFlags.fullyCharged = true;

				battParams_sram.capacityInCCAccumulated = CCGASG_ReadAccumulatedCC();

				// [dȂAEEPROMłXV
				int16_t temp = CCGASG_Acc2mAh(battParams_sram.capacityInCCAccumulated);
				if(temp != battParams.fullChargeCapacity) {
					battParams.fullChargeCapacity = temp;
				}
			}
		}
	}
}

/***********************************************/
/*! \brief VADC\ݒ
 *
 * VADC͕bɊi[܂(VCCADCʂł)Ax͖svłB
 *
 * 5bɂقƺ̉x𒲂ׂ悤VADC\ݒ肵܂Abł͂܂B
 */
static void configureVADC() {
	static uint8_t counter = 0;

	++counter;

	if(counter == 4) {
		VADC_ScanConfig((vadcIndex_t)HIGHEST_CELL, (vadcIndex_t)HIGHEST_VADC, (vadcIndex_t)0);
		counter = 0;
	} else if (counter == 2) {
		VADC_ScanConfig((vadcIndex_t)HIGHEST_CELL, (vadcIndex_t)0, (vadcIndex_t)VTEMP);
	} else {
		VADC_ScanConfig((vadcIndex_t)HIGHEST_CELL, (vadcIndex_t)0, (vadcIndex_t)0);
	}
}

/******************************************/
/*! \brief \ȂDUVR֎~
 */
static void disableDUVRIfPossible()
{
	if ( !(FCSR & (1<<DUVRD)) ) {
		stateFlags.inDUVR = true;
		if( SUCCESS == DUVR_DisableCheck() ){
			stateFlags.inDUVR = false;
		}
	}
}

/******************************************/
/*! \brief ǂꂩxُ킪ꍇɐ^Ԃ܂B
 *
 * \retval	true	x(drɑ΂)Ⴗ̂ǂłB
 * \retval	false	x͓drɑ΂OKłB
 */
static bool anyTemperatureError() {
	return (errorFlags.cellTemperatureTooHigh || errorFlags.cellTemperatureTooLow );
}

/******************************************/
/*! \brief ꂽꍇܰ̂ֈڍs
 */
static void enterPoweroff()
{
#ifdef POWEROFF_ENABLED
	SLEEP_ENTER_POWER_OFF();
#else
	FETCTRL_DisableFets();
	stateFlags.simulatePowerOff = true;
#endif
}

/***********************************/
/*! \brief SBD߂
 *
 * ǂ݂ƌꂩ̂ǂ炩𔻒f - ɂď
 */
static void handleSBSCommand() {
	taskFlags.newSbsCommandAvailable = false;

	bool send_ack = true;

	switch (sbs.command){
	case (SBS_WRITE | SBSCMD_manufacturerAccess):				// SBSCMD_manufacturerAccess
		{
			break;
		}
	case (SBS_READ | SBSCMD_manufacturerAccess):
		{
			// ׂ: Ulu
			sbs.payloadW = 0x00;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_WRITE | SBSCMD_remainingCapacityAlarm):			// SBSCMD_remainingCapacityAlarm
		{
			battParams.remainingCapacityAlarm = sbs.payloadW;
			break;
		}
	case (SBS_READ | SBSCMD_remainingCapacityAlarm):			// SBSCMD_remainingCapacityAlarm
		{
			sbs.payloadW = battParams.remainingCapacityAlarm;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_WRITE | SBSCMD_remainingTimeAlarm):				// SBSCMD_remainingTimeAlarm
		{
			battParams.remainingTimeAlarm = sbs.payloadW;
			break;
		}
	case (SBS_READ | SBSCMD_remainingTimeAlarm):				// SBSCMD_remainingTimeAlarm
		{
			sbs.payloadW = battParams.remainingTimeAlarm;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_batteryMode):						// SBSCMD_batteryMode
		{
			// ޯ2`5FCSR(FET/ڼ޽)ǉBޯĂ͗\񂳂Ăꂢ܂A ɂS炸gp
			// ܂Aޯ1011ɾٕtɂĂ̏ǉ
			uint16_t temp = (FCSR<<2);
#if BATTPARAM_CELLS_IN_SERIES >= 2
			temp |= ( (BALANCING_FET1_PORT & (1<<FET1)) << (BATTMODE_BALANCING_CELL1 - FET1));
			temp |= ( (BALANCING_FET2_PORT & (1<<FET2)) << (BATTMODE_BALANCING_CELL2 - FET2));
#endif
			sbs.payloadW = battParams.batteryMode | temp;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_WRITE | SBSCMD_atRate):							// SBSCMD_atRate
		{
			battParams_sram.atRate = (int16_t)sbs.payloadW;
			break;
		}
	case (SBS_READ | SBSCMD_atRate):							// SBSCMD_atRate
		{
			sbs.payloadW = (uint16_t)battParams_sram.atRate;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_atRateTimeToFull):					// SBSCMD_atRateTimeToFull
		{
			sbs.payloadW = GASG_TimeToFull(battParams_sram.atRate);
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_atRateTimeToEmpty):					// SBSCMD_atRateTimeToEmpty
		{
			sbs.payloadW = GASG_TimeToEmpty(battParams_sram.atRate);
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_atRateOK):							// SBSCMD_atRateOK
		{
			sbs.payloadW = GASG_AtRateOK(battParams_sram.atRate);
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_temperature):						// SBSCMD_temperature
		{
			sbs.payloadW = coreTemperature;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_voltage):							// SBSCMD_voltage
		{
			sbs.payloadW = VADC_readCellVoltage( CELL2 )+ VADC_readCellVoltage( CELL1 );
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_current):							// SBSCMD_current
		{
			sbs.payloadW = BATTCUR_Ticks2mA( BATTCUR_GetOffsetCalibratedCurrent() );
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_averageCurrent):					// SBSCMD_averageCurrent
		{
			sbs.payloadW = BATTCUR_Ticks2mA( BATTCUR_GetAverageCurrent() );
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_maxError):							// SBSCMD_maxError
		{
			// ׂ(폜): ޯWIREoRōsȂ΂ȂȂƂ邽߁AǂݍݎsimulatePowerOff
			stateFlags.simulatePowerOff = false;
			// ׂ: ԓŋUԓu
			sbs.payloadW = 0x0000;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_relativeStateOfCharge):				// SBSCMD_relativeStateOfCharge
		{
			sbs.payloadW = GASG_StateOfCharge(BATTCUR_GetAverageCurrent(), battParams_sram.capacityInCCAccumulated);
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_absoluteStateOfCharge):				// SBSCMD_absoluteStateOfCharge
		{
			sbs.payloadW = GASG_StateOfCharge(BATTCUR_GetAverageCurrent(), CCGASG_mAh2Acc(battParams.designCapacity));
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_remainingCapacity):					// SBSCMD_remainingCapacity
		{
			sbs.payloadW = CCGASG_Acc2mAh(GASG_RemainingCapacity(BATTCUR_GetAverageCurrent()));
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_fullChargeCapacity):				// SBSCMD_fullChargeCapacity
		{
			sbs.payloadW = battParams.fullChargeCapacity;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_runTimeToEmpty):					// SBSCMD_runTimeToEmpty
		{
			int32_t temp = BATTCUR_GetOffsetCalibratedCurrent();
			temp = BATTCUR_Ticks2mA(temp);
			sbs.payloadW = GASG_TimeToEmpty( (int16_t)temp );
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_averageTimeToEmpty):				// SBSCMD_averageTimeToEmpty
		{
			int32_t temp = BATTCUR_GetAverageCurrent();
			temp = BATTCUR_Ticks2mA(temp);
			sbs.payloadW = GASG_TimeToEmpty((int16_t)temp);
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_averageTimeToFull):					// SBSCMD_averageTimeToFull
		{
			int32_t temp = BATTCUR_GetAverageCurrent();
			temp = BATTCUR_Ticks2mA(temp);
			sbs.payloadW = GASG_TimeToFull((int16_t)temp);
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_chargingCurrent):					// SBSCMD_chargingCurrent
		{
			sbs.payloadW = battParams.chargingCurrent;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_chargingVoltage):					// SBSCMD_chargingVoltage
		{
			sbs.payloadW = battParams.chargingVoltage;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_batteryStatus):						// SBSCMD_batteryStatus
		{
			sbs.payloadW =   
			  (         stateFlags.chargingProhibited << BATTSTAT_OVER_CHARGED_ALARM_BIT)
			| (             errorFlags.voltageTooHigh << BATTSTAT_TERMINATE_CHARGE_ALARM_BIT)
			| (  (bool)(VREGMON_ConditionTriggered()) << BATTSTAT_VREGMON_TRIGGERED_BIT)
			| (     errorFlags.cellTemperatureTooHigh << BATTSTAT_OVER_TEMP_ALARM_BIT)
			| (           sbsFlags.terminateDischarge << BATTSTAT_TERMINATE_DISCHARGE_ALARM_BIT)
			| (      BATTPROT_IsProtectionTriggered() << BATTSTAT_BATTERY_PROTECTION_TRIGGERED_BIT)
			| (       sbsFlags.remainingCapacityAlarm << BATTSTAT_REMAINING_CAPACITY_ALARM_BIT)
			| (           sbsFlags.remainingTimeAlarm << BATTSTAT_REMAINING_TIME_ALARM_BIT)
			| (! errorFlags.criticalConditionDetected << BATTSTAT_INITIALIZED_BIT)
			| (          BATTCUR_IsDischargeOngoing() << BATTSTAT_DISCHARGING_BIT)
			| (                 sbsFlags.fullyCharged << BATTSTAT_FULLY_CHARGED_BIT)
			| (              sbsFlags.fullyDischarged << BATTSTAT_FULLY_DISCHARGED_BIT) ;
			
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_cycleCount):						// SBSCMD_cycleCount
		{
			sbs.payloadW = BATTPARAM_GetCycleCount();
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_designCapacity):					// SBSCMD_designCapacity
		{
			sbs.payloadW = battParams.designCapacity;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_designVoltage):						// SBSCMD_designVoltage
		{
			sbs.payloadW = battParams.designVoltage;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_specificationInfo):					// SBSCMD_specificationInfo
		{
			sbs.payloadW = battParams.specificationInfo;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_manufactureDate):					// SBSCMD_manufactureDate
		{
			sbs.payloadW = battParams.manufactureDate;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_serialNumber):						// SBSCMD_serialNumber
		{
			sbs.payloadW = battParams.serialNumber;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_manufacturerName):					// SBSCMD_manufacturerName
		{
			BATTPARAM_GetString( (BATTPARAM_blockParameter_t*)&battParams.manufacturerName, (SBS_command_t*)&sbs );
			Comm_SbsBlockCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_deviceName):						// SBSCMD_deviceName
		{
			BATTPARAM_GetString( (BATTPARAM_blockParameter_t*)&battParams.deviceName, (SBS_command_t*)&sbs );
			Comm_SbsBlockCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_deviceChemistry):					// SBSCMD_deviceChemistry
		{
			BATTPARAM_GetString( (BATTPARAM_blockParameter_t*)&battParams.deviceChemistry, (SBS_command_t*)&sbs );
			Comm_SbsBlockCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_manufacturerData):					// SBSCMD_manufacturerData
		{
			BATTPARAM_GetString( (BATTPARAM_blockParameter_t*)&battParams.manufacturerData, (SBS_command_t*)&sbs );
			Comm_SbsBlockCommandReply( &sbs );
			break;
		}
	case (SBS_WRITE | SBSCMD_authentication):					// SBSCMD_authentication
		{
			// JԂŔF؂s
			taskFlags.doAuthentication = true;
			break;
		}
	case (SBS_READ | SBSCMD_authentication):
		{
			// F؂ꂽүނւ̈ʒuwq擾
			sbsReply = AUTH_GetResponse();
			// ʐMPʕɔF؂ꂽүނւ̈ʒuwqn܂B
			Comm_SbsBlockCommandReply( sbsReply );
			break;
		}
	case (SBS_WRITE | SBSCMD_shuntCalibration):				// SBSCMD_shuntCalibration
		{
			// mł̕RłB
			battParams.shuntResistance = sbs.payloadW;
			BATTCUR_CalculateMagicNumber(sbs.payloadW);
			CCGASG_CalculateMagicalNumbers(sbs.payloadW);
			break;
		}
	case (SBS_READ | SBSCMD_shuntCalibration):
		{
			sbs.payloadW = battParams.shuntResistance;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_WRITE | SBSCMD_FETdisable):					// SBSCMD_FETdisable
		{
			if(sbs.payloadW & (1<<FETDIS_CHARGE)) {
				sbsFlags.forceChargeFETDisabled = true;
				FETCTRL_DisableChargeFet();
			} else {
				sbsFlags.forceChargeFETDisabled = false;
			}
			
			if(sbs.payloadW & (1<<FETDIS_DISCHARGE)) {
				sbsFlags.forceDischargeFETDisabled = true;
				FETCTRL_DisableDischargeFet();
			} else {
				sbsFlags.forceDischargeFETDisabled = false;
			}
			break;
		}
	case (SBS_WRITE | SBSCMD_storageMode):						// SBSCMD_storageMode
		{
			// Mꂪꍇܰ̂ֈڍs
			if(sbs.payloadW == 0xFADE) {
				enterPoweroff();
			}
			break;
		}
	case (SBS_READ | SBSCMD_temperatureNTC2):					// SBSCMD_temperatureCell2
		{
			// нȂ̏ꍇAlԂ܂B
			// нL̏ꍇA2ڂ̉xԂ܂B
#if HIGHEST_VADC < DEF_VADC1
			sbs.payloadW = 0x0000;
#else
			sbs.payloadW = cellTemperature[1];
#endif
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_temperatureNTC1):					// SBSCMD_temperatureCell1
		{
			// нȂ̏ꍇAlԂ܂B
			// нL̏ꍇA1ڂ̉xԂ܂B
#if HIGHEST_VADC < DEF_VADC0
			sbs.payloadW = 0x0000;
#else
			sbs.payloadW = cellTemperature[0];
#endif
			Comm_SbsWordCommandReply( &sbs );
			break;
		}

	case (SBS_READ | SBSCMD_voltageCell4):						// SBSCMD_OptionalMfgFunction5
																// SBSCMD_voltageCell4			// ʓIOptionalMfgFunction4ƂĎQƁAǂݍݐp
		{
			// sbs.payloadW=VADC_readCellVoltage(CELL4);
			// ׂ:lŋUlu
			sbs.payloadW = 0x0000;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_voltageCell3):						// SBSCMD_voltageCell3			// ʓIOptionalMfgFunction3ƂĎQƁAǂݍݐp
		{
			//sbs.payloadW = VADC_readCellVoltage( CELL3 );
			// TODO replace dummy reply value with correct reply.
			sbs.payloadW = 0x0000;
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_voltageCell2):						// SBSCMD_voltageCell2			// ʓIOptionalMfgFunction2ƂĎQƁAǂݍݐp
		{
			sbs.payloadW = VADC_readCellVoltage( CELL2 );
			Comm_SbsWordCommandReply( &sbs );
			break;
		}
	case (SBS_READ | SBSCMD_voltageCell1):						// SBSCMD_voltageCell1			// ʓIOptionalMfgFunction1ƂĎQƁAǂݍݐp
		{
			sbs.payloadW = VADC_readCellVoltage( CELL1 );
			Comm_SbsWordCommandReply( &sbs );
			break;
		}

	default:
		// x߁AACK𑗂ȂłB
		send_ack = false;
		break;
	}

	// ݖ߂̏ꍇANACK/ACK𑗏o
	if( ! (sbs.command & SBS_READ) ) {
		if( send_ack ) {
			Comm_SendACK();
		}
	}
}
